/*
 * Copyright (C) 2004, 2005 BLADOX, s.r.o.  All rights reserved.
 *
 * This file is part of an example program for Turbo. This example
 * program may be used, distributed and modified without limitation.
 *
 */

#include <config.h>
#include <turbo/turbo.h>

#include <avr/sfr_defs.h>
#include <avr/io.h>

#include <stdlib.h>
#include <string.h>
#include <ctype.h>

/* *INDENT-OFF* */

lc_char PROGMEM lc_Pager[] = {
  LC_EN ("Pager") 
  LC_FR ("SemaSMS")
  LC_END
};

lc_char PROGMEM lc_Help[]={
  LC_EN("Help")
  LC_FR("Aide")
  LC_CZ("Napoveda")
  LC_DE("Hilfe")
  LC_END
};

lc_char PROGMEM lc_Config[] = {
  LC_EN ("Config")
  LC_FR ("Configuration") 
  LC_CZ ("Nastaveni") 
  LC_DE ("Konfiguration") 
  LC_END
};

lc_char PROGMEM lc_New_Number[] = {
  LC_EN ("New Number")
  LC_FR ("Nouveau Nr") 
  LC_CZ ("Nove cislo") 
  LC_DE ("Neue Nummer")
  LC_END
};

lc_char PROGMEM lc_Numbers[] = {
  LC_EN ("Numbers") 
  LC_FR ("Num\5ros")
  LC_CZ ("Cisla") 
  LC_DE ("Nummern") 
  LC_END
};

lc_char PROGMEM lc_State[] = {
  LC_EN ("State")
  LC_FR ("Status") 
  LC_CZ ("Stav") 
  LC_DE ("Status")
  LC_END
};

lc_char PROGMEM lc_On[]={
        LC_EN("  On")
	LC_FR("  Actif")
        LC_DE("  Aktiv")
        LC_END
};

lc_char PROGMEM lc_Off[]={
        LC_EN("  Off")
	LC_FR("  Non actif")
        LC_DE("  Inaktiv")
        LC_END
};

lc_char PROGMEM lc_Low[]={
        LC_EN("  0")
	LC_FR("  Bas")
        LC_END
};

lc_char PROGMEM lc_Hi[]={
        LC_EN("  1")
	LC_FR("  Haut")
        LC_END
};

lc_char PROGMEM lc_FlipFlop[]={
        LC_EN("  Flip-Flop")
        LC_END
};

lc_char PROGMEM lc_Yes[]={
        LC_EN("  Yes")
	LC_FR("  Oui")
        LC_DE("  Ja")
        LC_END
};

lc_char PROGMEM lc_No[]={
        LC_EN("  No")
	LC_FR("  Non")
        LC_DE("  Nein")
        LC_END
};

lc_char PROGMEM lc_Less[]={
        LC_EN("  <=Threshold")
	LC_FR("  Seuil <=")
        LC_DE("  <= Grenzwert")
        LC_END
};

lc_char PROGMEM lc_More[]={
        LC_EN("  >Threshold")
	LC_FR("  Seuil >")
        LC_DE("  > Grenzwert")
        LC_END
};

lc_char PROGMEM lc_Clear_SIM_SMS[]={
        LC_EN("Clear SIM SMS")
	LC_FR("Vider SMS de SIM")
        LC_CZ("Smazat SIM SMS")
        LC_DE("Entfernen der SIM-SMS")
        LC_END
};

lc_char PROGMEM lc_SMS_Deleted[]={
        LC_EN("All Messages on SIM Deleted")
	LC_FR("Tous messages effac\5s de la SIM")
        LC_CZ("Vsechny zpravy na SIM smazany")
        LC_DE("Alle SMS auf der SIM wurden entfernt.")
        LC_END
};

lc_char PROGMEM lc_Please_Wait[]={
        LC_EN("Please Wait")
	LC_FR("Attendre svp")
        LC_CZ("Prosim cekejte")
        LC_DE("Bitte warten.")
        LC_END
};

lc_char PROGMEM lc_Input[]={
        LC_EN("  Input")
	LC_FR("  Entr\5e")
        LC_DE("  Eingang")
        LC_END
};

lc_char PROGMEM lc_Output[]={
        LC_EN("  Output")
	LC_FR("  Sortie")
        LC_DE("  Ausgang")
        LC_END
};

lc_char PROGMEM lc_In[]={
        LC_EN("IN")
	LC_FR("ENTREE")
        LC_DE("EINGANG")
	LC_END
};

lc_char PROGMEM lc_Out[]={
        LC_EN("OUT")
	LC_FR("SORTIE")
        LC_DE("AUSGANG")
        LC_END
};

lc_char PROGMEM lc_ADC[]={
        LC_EN("  ADC")
	LC_FR("  ANALOGIQUE")
        LC_END
};

lc_char PROGMEM lc_Label[]={
        LC_EN("Label")
	LC_FR("Etiquette")
        LC_CZ("Oznaceni")
        LC_DE("Name")
        LC_END
};

lc_char PROGMEM lc_Enter_Label[]={
        LC_EN("Enter Label:")
	LC_FR("Entrez \5tiquette:")
        LC_CZ("Zadejte oznaceni:")
        LC_DE("Eingabe Name:")
        LC_END
};

lc_char PROGMEM lc_No_Labels[]={
        LC_EN("No PIN Label Set")
	LC_FR("Aucune \5tiquette enregistr\5e")
        LC_CZ("Neni nastavene zadne oznaceni PINu")
        LC_DE("Kein PIN-Name gesetzt.")
        LC_END
};

lc_char PROGMEM lc_PIN_A[]={
        LC_EN("P5")
        LC_END
};

lc_char PROGMEM lc_PIN_B[]={
        LC_EN("P6")
        LC_END
};

lc_char PROGMEM lc_PIN_C[]={
        LC_EN("P7")
        LC_END
};

lc_char PROGMEM lc_PIN_D[]={
        LC_EN("P8")
        LC_END
};

lc_char PROGMEM lc_PIN_E[]={
        LC_EN("P9")
        LC_END
};

lc_char PROGMEM lc_PIN_F[]={
        LC_EN("P10")
        LC_END
};

lc_char PROGMEM lc_PIN_G[]={
        LC_EN("P11")
        LC_END
};

lc_char PROGMEM lc_PIN_H[]={
        LC_EN("P12")
        LC_END
};

lc_char PROGMEM lc_PIN_I[]={
        LC_EN("P13")
        LC_END
};

#ifdef CONFIG_TURBO_LITE

lc_char PROGMEM lc_PIN_J[]={
        LC_EN("P1")
        LC_END
};

lc_char PROGMEM lc_PIN_K[]={
        LC_EN("P2")
        LC_END
};

lc_char PROGMEM lc_PIN_L[]={
        LC_EN("P3")
        LC_END
};

lc_char PROGMEM lc_PIN_M[]={
        LC_EN("P4")
        LC_END
};

#endif

lc_char PROGMEM lc_IO[]={
        LC_EN("I/O")
	LC_FR("E/S")
        LC_END
};

lc_char PROGMEM lc_IOA[]={
        LC_EN("I/O/ADC")
	LC_FR("E/S/ANA")
        LC_END
};

lc_char PROGMEM lc_On_Level[]={
        LC_EN("On Level")
	LC_FR("Niveau Actif")
        LC_DE("Aktivniveau") 
        LC_END
};

lc_char PROGMEM lc_Value[]={
        LC_EN("Value")
	LC_FR("Valeur")
        LC_DE("Wert")
        LC_END
};

lc_char PROGMEM lc_RESET_Value[]={
        LC_EN("RESET Value")
	LC_FR("Valeur initiale")
        LC_DE("Initialwert")
        LC_END
};

lc_char PROGMEM lc_ALARM[]={
        LC_EN("ALARM!\n")
	LC_FR("ALARME!\n")
        LC_END
};

lc_char PROGMEM lc_Alarm[]={
        LC_EN("Alarm")
	LC_FR("Alarme")
        LC_END
};

lc_char PROGMEM lc_Alarm_Threshold[]={
        LC_EN("Threshold")
	LC_FR("Seuil")
        LC_EN("Grenzwert")
	LC_END
};

lc_char PROGMEM lc_Alarm_Level[]={
        LC_EN("Level")
	LC_FR("Niveau")
        LC_DE("Niveau")
        LC_END
};

lc_char PROGMEM lc_Version[]={
        LC_EN("Version")
	LC_FR("Version")
        LC_CZ("Verze")
        LC_END
};

lc_char PROGMEM lc_Poll_Interval[]={
        LC_EN("Poll Interval")
	LC_FR("Int. mesure")
        LC_CZ("Int. mereni")
        LC_DE("Abfrageintervall")
        LC_END
};

lc_char PROGMEM lc_Poll_Interval_Error[]={
        LC_EN("Cannot set Poll Interval, 30 sec used.")
	LC_FR("Ne peut appliquer la valeur, 30 secondes par d\5faut.")
        LC_CZ("Nelze nastavit interval mereni, pouzito 30 sekund.")
        LC_DE("Das Abfrageintervall kann nicht gesetzt werden. 30 s werden verwendet.")
        LC_END
};

lc_char PROGMEM lc_Help_Poll_Interval[]={
        LC_EN("Poll Interval defines interval between inputs chacking for alarm detection. In seconds, phone can use approximate value.")
	LC_FR("Intervalle de mesure d\5finit le temps entre les mesures des entr\5es en secondes. Utilis\5 pour la d\5tection des alarmes.")
        LC_CZ("Interval mereni rika, jak casto se meri hodnota vstupu pro detekci alarmu. Udava se v sekundach, telefon muze zvolit pribliznou hodnotu.")
        LC_DE("Das Abfrageintervall definiert die Zeit, in der die Alarmerkennung aktiviert wird, in Sekunden (Circa-Wert).")
        LC_END
};

lc_char PROGMEM lc_Poll_Interval_Set[]={
        LC_EN("Poll Interval set to ")
	LC_FR("Intervalle de mesure mis a ")
        LC_CZ("Interval mereni nastaven na ")
        LC_DE("Abfrageintervall gesetzt auf ")
        LC_END
};

lc_char PROGMEM lc_Seconds_2[]={
        LC_EN(" seconds.")
	LC_FR(" secondes.")
        LC_CZ(" sekund.")
        LC_DE(" Sekunden.")
        LC_END
};

lc_char PROGMEM lc_Seconds[]={
        LC_EN("Seconds:")
	LC_FR("Secondes:")
        LC_CZ("Sekund:")
        LC_DE("Sekunden:")
        LC_END
};


/* *INDENT-ON* */

#ifdef CONFIG_TURBO_LITE
#define MAX_PIN	('M'-'A'+1)
#else
#define MAX_PIN	('I'-'A'+1)
#endif

#define DEF_ON		1
#define DEF_OFF		0

#define DEF_IN		0
#define DEF_OUT		1
#define DEF_ADC		2

typedef struct _Pin		// number capabilities
{
  u8 dir;			// I/O input=DEF_IN, output=DEF_OUT
  u8 init_val;			// DEF_ON/DEF_OFF
  u8 on_level;			// 0/1
  u8 *label;			// PIN label
  u8 alarm;			// 0/1 for I/ADC 0=no, 1=yes
  u16 adc_threshold;		// threshold ADC value
  u8 alarm_val;			// 0/1/2 for digital input (2=flip-flop), 0=less, 1=more for ADC
}
Pin;

typedef struct _Pers_mem
{
  SEdge *numbers;		// pointer to msisdns
  Pin pin[MAX_PIN];
  u8 poll_interval;
}
Pers_mem;

Pers_mem *pers_mem = NULL;

u8 alarm_reported[MAX_PIN];
u8 alarm_flipflop[MAX_PIN];
u8 poll_int;

u8 ABC_val (u8 * ret, u8 val, u8 * text, u8 * A_text, u8 * B_text,
	    u8 * C_text)
{
  u8 *res;
  u8 j, n;
  u8 t_A[15];
  u8 t_B[15];
  u8 t_C[15];
  u8 *t_list[3];

  t_list[0] = t_A;
  t_list[1] = t_B;
  t_list[2] = t_C;

  memcpy (t_A, A_text, strlen (A_text) + 1);
  memcpy (t_B, B_text, strlen (B_text) + 1);
  n = 2;
  if (C_text)
  {
    memcpy (t_C, C_text, strlen (C_text) + 1);
    n = 3;
  }
  if (val == 0)
  {
    t_A[0] = '*';
  }
  else if (val == 1)
  {
    t_B[0] = '*';
  }
  else
  {
    t_C[0] = '*';
  }

  j = val + 1;

  res = select_item (n, t_list, text, NULL, j, Q_SELECT_ITEM_CHOICE);
  j = get_tag (res, T_RESULT);
  if (j != 0)
  {
    j++;			// tag
    j++;			//len
    if (res[j] == 0x10)
      return APP_END;		// end
    if (res[j] == 0x11 || res[j] == 0x12)
      return APP_BACK;		// back
  }
  j = get_tag (res, T_ITEM_ID);
  if (j != 0)
  {
    j++;			//tag
    j++;			//len
    if (res[j] == 1)
      *ret = 0;
    else if (res[j] == 2)
      *ret = 1;
    else
      *ret = 2;
  }
  return APP_OK;
}

u8 pager_numbers (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    ctx->eE = rw (&pers_mem->numbers);
  }
  else if (action == APP_LEAVE)
  {
    ctx->eE = NULL;
  }
  return APP_OK;
}

static u8 PROGMEM ef_sms_path[] = { 0x3F, 0x00, 0x7F, 0x10, 0x6F, 0x3C };

void refsms ()
{
  u8 file_buf[6];

  dbsp (">refresh_sms\n");
  memcpy (file_buf, ef_sms_path, sizeof (ef_sms_path));
  refresh (Q_REFRESH_SIM_FILE_CHANGE, 1, 6, file_buf);
  dbsp ("<refresh_sms\n");
}

void refsms_d (File_apdu_data * fa)
{
  sim (fa->ins, fa->p1, fa->p2, fa->p3, fa->data);
  fa->data[0] = 0;
  sim (fa->ins, fa->p1, fa->p2, fa->p3, fa->data);
  refsms ();
}

u8 pager_clear_sim_sms (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u16 ret;
    u8 nr_sms;
    u8 rec_len;
    u8 i;
    u8 path[6];

    dbsp ("Clear SIM SMS\n");
    memcpy (path, ef_sms_path, sizeof (ef_sms_path));

    play_tone (locale (lc_Please_Wait), TONE_POSITIVE, DURATION_SEC, 1);
    ret = select (path, 3);
    sim (ME_CMD_GET_RESPONSE, 0, 0, ret, buf_A ());
    nr_sms =
      ((u16) ((u16) (buf_A ()[2]) << 8) | (buf_A ()[3])) / buf_A ()[14];
    rec_len = buf_A ()[14];

    for (i = 0; i < nr_sms; i++)
    {
      dbsp ("DEL SMS ");
      dbch (i + 1);
      dbc ('\n');
      buf_A ()[0] = 0;
      sim (ME_CMD_UPDATE_RECORD, i + 1, 0x04, rec_len, buf_A ());
    }

    select (0, 0);

    refsms ();
    i = display_text (locale (lc_SMS_Deleted), NULL);
    if (i == APP_END)
      return APP_END;
    return APP_BACK;
  }
  return APP_OK;
}

u8 pager_number_delete (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res;

    res = yesno (NULL, 1, 1);
    if (res == APP_END)
      return APP_END;
    if (res == APP_YES)
    {
      // DELETE
      SEdge *e, *e1;
      SNode *n = ctx->parent->f;
      u8 *nc;

      e1 = e = rw (&pers_mem->numbers);
      while (e && rw (&e->t) != n)
      {
	e1 = e;
	e = rw (&e->next);
      }
      if (e)
      {
	if (e == e1)
	  ww (&pers_mem->numbers, rw (&e->next));
	else
	  ww (&e1->next, rw (&e->next));

	efree (e);
	nc = rw (&n->p);
	efree (nc);
	efree (rw (&n->text));
	efree (n);
      }
      spider_back (ctx);
    }
    return APP_BACK;
  }
  return APP_OK;
}

u8 pager_number_view (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *buf = buf_B ();
    u8 *r = buf;
    SNode *np = ctx->parent->f;
    u8 *s = msisdn2str (rw (&np->p), MSISDN_ADN, MEM_R);
    u8 i;

    r = sprints (r, s);
    r = sprintc (r, '\0');
    free (s);
    i = display_text (buf, NULL);
    if (i != APP_END)
      return APP_BACK;
    return i;
  }
  return APP_OK;
}

extern SNodeP pager_number_delete_n;
extern SNodeP pager_number_view_n;

u8 pager_number_show (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    spider_append_r (ctx, &pager_number_delete_n);
    spider_append_r (ctx, &pager_number_view_n);
  }
  else if (action == APP_LEAVE)
  {
    spider_clear_r (ctx);
  }
  return APP_OK;
}

extern SNodeP pager_n;
extern SNodeP pager_n_numbers;

u8 pager_new_number (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    u8 *t;
    u8 *nr;
    SNode *n;
    SEdge *e, *e1;
    u8 j, i;
    u8 alpha[ALPHA_LEN];

    res = msisdn (alpha);
    if (res == ENULL)
      goto X1;
    if (res == NULL)
      goto X2;
    n = emalloc (sizeof (SNode));
    if (n == NULL)
      goto X3;
    e = emalloc (sizeof (SEdge));
    if (n == NULL)
      goto X4;
    j = strlen (alpha);
    t = emalloc (j + 1);
    if (t == NULL)
      goto X5;
    nr = msisdncpy (res, MSISDN_ADN, MEM_E);
    if (nr == NULL)
      goto X6;
    memcpy (t, alpha, j);
    wb (t + j, '\0');

    ww (&n->cb, pager_number_show);
    ww (&n->text, t);
    ww (&n->p, nr);

    ww (&e->next, rw (&pers_mem->numbers));
    ww (&e->t, n);
    ww (&e->f, &pager_n_numbers);
    wb (&e->source, MEM_F_P | MEM_T_E);
    ww (&pers_mem->numbers, e);
    goto X2;
  X6:
    efree (t);
  X5:
    efree (e);
  X4:
    efree (n);
  X3:
    perror (ERR_NO_EEPROM);
  X2:
    return APP_BACK;
  X1:
    return APP_END;
  }
  return APP_OK;
}

#define CONFIG_ADC_CHANNEL_CHANGE_DELAY_MILISEC (5)
#define ADC_INTERNAL_REF_VOLT (0xC0)

// Measure Voltage on pin of A/D MUX
u16 adc_measure (u8 channel)
{
  u16 msecs;
  u8 i;
  u16 voltage;

  if (channel >= 8)
    return 0;

  //Use Voltage reference as set in init_adc function
  //Select ADC MUX channel
  outb (ADMUX, (ADC_INTERNAL_REF_VOLT | channel));

  for (i = 0; i < 20; i++)
  {
    // wait for a while
    // keep in mind Mr. Nyquist
    // this delay will influence sampling frequency !
    for (msecs = 0; msecs < CONFIG_ADC_CHANNEL_CHANGE_DELAY_MILISEC; msecs++)
      delay_1ms ();

    //Disable high speed ADC mode
    cbi (SFIOR, ADHSM);

    // Enable ADC
    // Start conversion
    // Disable Free running mode
    // ADCclk=Fosc/16
    outb (ADCSR, 0xC4);
    // Wait here when conversion is not completed with data registers updating
    while ((inb (ADCSR) & (1 << ADIF)) == 0);

    //clear ADCIF flag
    sbi (ADCSR, ADIF);

    //store measured voltage
    voltage = inw (ADCW);

    // Disable ADC
    outb (ADCSR, 0x00);
  }

  //Turn Off Internal Voltage reference 2,56V
  outb (ADMUX, 0x00);

  return voltage;
}

/*
PIN TABLE:
0	A	P5
1	B	P6
2	C	P7
3	D	P8
4	E	P9
5	F	P10
6	G	P11
7	H	P12
8	I	P13

Only for Turbo Lite:
9	J	P1
10	K	P2
11	L	P3
12	M	P4
*/

u16 get_pin_adc (u8 pin)	//pin==9-12
{
  u16 voltage;

  switch (pin)
  {
    case 9:
      voltage = adc_measure (2);
      break;
    case 10:
      voltage = adc_measure (5);
      break;
    case 11:
      voltage = adc_measure (3);
      break;
    case 12:
      voltage = adc_measure (6);
      break;
    default:
      voltage = 0;
      break;
  }
  asm __volatile__ ("nop");	//wait

  return voltage;
}

void set_dir (u8 pin, u8 val)	// val is DEF_IN, DEF_OUT, DEF_ADC
{
  switch (pin)
  {
    case 0:
      if (val == DEF_IN)
	cbi (DDRG, DD1);
      else
	sbi (DDRG, DD1);
      break;
    case 1:
      if (val == DEF_IN)
	cbi (DDRC, DD2);
      else
	sbi (DDRC, DD2);
      break;
    case 2:
      if (val == DEF_IN)
	cbi (DDRC, DD1);
      else
	sbi (DDRC, DD1);
      break;
    case 3:
      if (val == DEF_IN)
	cbi (DDRC, DD6);
      else
	sbi (DDRC, DD6);
      break;
    case 4:
      if (val == DEF_IN)
	cbi (DDRC, DD4);
      else
	sbi (DDRC, DD4);
      break;
    case 5:
      if (val == DEF_IN)
	cbi (DDRA, DD7);
      else
	sbi (DDRA, DD7);
      break;
    case 6:
      if (val == DEF_IN)
	cbi (DDRC, DD7);
      else
	sbi (DDRC, DD7);
      break;
    case 7:
      if (val == DEF_IN)
	cbi (DDRA, DD4);
      else
	sbi (DDRA, DD4);
      break;
    case 8:
      if (val == DEF_IN)
	cbi (DDRA, DD6);
      else
	sbi (DDRA, DD6);
      break;
    case 9:
      if (val == DEF_IN)
	cbi (DDRF, DD2);
      else if (val == DEF_OUT)
	sbi (DDRF, DD2);
      else
      {
	cbi (DDRF, DD2);
	cbi (PORTF, PORT2);
      }
      break;
    case 10:
      if (val == DEF_IN)
	cbi (DDRF, DD5);
      else if (val == DEF_OUT)
	sbi (DDRF, DD5);
      else
      {
	cbi (DDRF, DD5);
	cbi (PORTF, PORT5);
      }
      break;
    case 11:
      if (val == DEF_IN)
	cbi (DDRF, DD3);
      else if (val == DEF_OUT)
	sbi (DDRF, DD3);
      else
      {
	cbi (DDRF, DD3);
	cbi (PORTF, PORT3);
      }
      break;
    case 12:
      if (val == DEF_IN)
	cbi (DDRF, DD6);
      else if (val == DEF_OUT)
	sbi (DDRF, DD6);
      else
      {
	cbi (DDRF, DD6);
	cbi (PORTF, PORT6);
      }
      break;
    default:
      break;
  }
  asm __volatile__ ("nop");	//wait
}

u8 out_pin_val (u8 pin)
{
  u8 on_level = rb (&pers_mem->pin[pin].on_level);
  u8 val = 0;

  switch (pin)
  {
    case 0:
      val = ((inb (PORTG)) & (1 << PORT1)) >> PORT1;
      break;
    case 1:
      val = ((inb (PORTC)) & (1 << PORT2)) >> PORT2;
      break;
    case 2:
      val = ((inb (PORTC)) & (1 << PORT1)) >> PORT1;
      break;
    case 3:
      val = ((inb (PORTC)) & (1 << PORT6)) >> PORT6;
      break;
    case 4:
      val = ((inb (PORTC)) & (1 << PORT4)) >> PORT4;
      break;
    case 5:
      val = ((inb (PORTA)) & (1 << PORT7)) >> PORT7;
      break;
    case 6:
      val = ((inb (PORTC)) & (1 << PORT7)) >> PORT7;
      break;
    case 7:
      val = ((inb (PORTA)) & (1 << PORT4)) >> PORT4;
      break;
    case 8:
      val = ((inb (PORTA)) & (1 << PORT6)) >> PORT6;
      break;
    case 9:
      val = ((inb (PORTF)) & (1 << PORT2)) >> PORT2;
      break;
    case 10:
      val = ((inb (PORTF)) & (1 << PORT5)) >> PORT5;
      break;
    case 11:
      val = ((inb (PORTF)) & (1 << PORT3)) >> PORT3;
      break;
    case 12:
      val = ((inb (PORTF)) & (1 << PORT6)) >> PORT6;
      break;
    default:
      break;
  }
  asm __volatile__ ("nop");	//wait

  if (val == on_level)
    return DEF_ON;

  return DEF_OFF;
}

void set_pin (u8 n, u8 val)	//val in DEF_ON, DEF_OFF
{
  u8 on_level = rb (&pers_mem->pin[n].on_level);

  if (val == DEF_ON)
    val = on_level;
  else
    val = !on_level;

  switch (n)
  {
    case 0:
      if (val != 0)
	sbi (PORTG, PORT1);
      else
	cbi (PORTG, PORT1);
      break;
    case 1:
      if (val != 0)
	sbi (PORTC, PORT2);
      else
	cbi (PORTC, PORT2);
      break;
    case 2:
      if (val != 0)
	sbi (PORTC, PORT1);
      else
	cbi (PORTC, PORT1);
      break;
    case 3:
      if (val != 0)
	sbi (PORTC, PORT6);
      else
	cbi (PORTC, PORT6);
      break;
    case 4:
      if (val != 0)
	sbi (PORTC, PORT4);
      else
	cbi (PORTC, PORT4);
      break;
    case 5:
      if (val != 0)
	sbi (PORTA, PORT7);
      else
	cbi (PORTA, PORT7);
      break;
    case 6:
      if (val != 0)
	sbi (PORTC, PORT7);
      else
	cbi (PORTC, PORT7);
      break;
    case 7:
      if (val != 0)
	sbi (PORTA, PORT4);
      else
	cbi (PORTA, PORT4);
      break;
    case 8:
      if (val != 0)
	sbi (PORTA, PORT6);
      else
	cbi (PORTA, PORT6);
      break;
    case 9:
      if (val != 0)
	sbi (PORTF, PORT2);
      else
	cbi (PORTF, PORT2);
      break;
    case 10:
      if (val != 0)
	sbi (PORTF, PORT5);
      else
	cbi (PORTF, PORT5);
      break;
    case 11:
      if (val != 0)
	sbi (PORTF, PORT3);
      else
	cbi (PORTF, PORT3);
      break;
    case 12:
      if (val != 0)
	sbi (PORTF, PORT6);
      else
	cbi (PORTF, PORT6);
      break;
    default:
      break;
  }

  asm __volatile__ ("nop");	//wait
}

u8 get_val_pin (u8 pin)
{
  u8 val = 0;

  switch (pin)
  {
    case 0:
      val = ((inb (PING)) & (1 << PIN1)) >> PIN1;
      break;
    case 1:
      val = ((inb (PINC)) & (1 << PIN2)) >> PIN2;
      break;
    case 2:
      val = ((inb (PINC)) & (1 << PIN1)) >> PIN1;
      break;
    case 3:
      val = ((inb (PINC)) & (1 << PIN6)) >> PIN6;
      break;
    case 4:
      val = ((inb (PINC)) & (1 << PIN4)) >> PIN4;
      break;
    case 5:
      val = ((inb (PINA)) & (1 << PIN7)) >> PIN7;
      break;
    case 6:
      val = ((inb (PINC)) & (1 << PIN7)) >> PIN7;
      break;
    case 7:
      val = ((inb (PINA)) & (1 << PIN4)) >> PIN4;
      break;
    case 8:
      val = ((inb (PINA)) & (1 << PIN6)) >> PIN6;
      break;
    case 9:
      val = ((inb (PINF)) & (1 << PIN2)) >> PIN2;
      break;
    case 10:
      val = ((inb (PINF)) & (1 << PIN5)) >> PIN5;
      break;
    case 11:
      val = ((inb (PINF)) & (1 << PIN3)) >> PIN3;
      break;
    case 12:
      val = ((inb (PINF)) & (1 << PIN6)) >> PIN6;
      break;
    default:
      break;
  }
  return val;
}

void delay_1ms (void)
{
  u16 i;

// NOTE! we assume clock 3MHz, it can be 2-4Mhz depending on used ME

  for (i = 0; i < 1000; i++)
  {
    __asm__ __volatile__ ("nop");
    __asm__ __volatile__ ("nop");
  }
}

u8 print_state (u8 * buf, u8 max_len)
{
  u8 i;
  u8 j;
  u8 *r = buf;

  j = 0;
  for (i = 0; i < MAX_PIN; i++)
    if (alarm_reported[i])
      j = 1;
  if (j)
    r = sprints (r, locale (lc_ALARM));

  for (i = 0; i < MAX_PIN; i++)
  {
    if (r - buf > max_len - 21)	// assume 21 is enough 9(label)+": "+"Output"+" 0\n\0"=9+2+6+4
    {
      r = sprintc (r, '\0');
      return r - buf;
    }

    if (rw (&pers_mem->pin[i].label) != NULL)
    {
      if (alarm_reported[i])
	r = sprintc (r, '!');
      r = sprints (r, rw (&pers_mem->pin[i].label));
      r = sprintc (r, ':');
      r = sprintc (r, ' ');
      if (rb (&pers_mem->pin[i].dir) == DEF_IN)
      {
//Input
	r = sprints (r, locale (lc_In));
	r = sprintc (r, ' ');
	r = sprintc (r, get_val_pin (i) + '0');
      }
      else if (rb (&pers_mem->pin[i].dir) == DEF_OUT)
      {
//Output
	r = sprints (r, locale (lc_Out));
	r = sprintc (r, ' ');
	if (out_pin_val (i) == DEF_ON)
	  r = sprints (r, locale (lc_On) + 2);
	else
	  r = sprints (r, locale (lc_Off) + 2);
      }
      else
      {
//ADC
	r = sprints (r, locale (lc_ADC) + 2);
	r = sprintc (r, ' ');
	r = sprinti (r, get_pin_adc (i));
      }

      r = sprintc (r, '\n');
    }
  }

  if (r == buf)
    r = sprints (r, locale (lc_No_Labels));

  r = sprintc (r, '\0');
  return r - buf;
}

u8 pager_state (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *buf = buf_B ();
    u8 i;

    print_state (buf, 240);
    i = display_text (buf, NULL);
    if (i == APP_END)
      return APP_END;
    return APP_BACK;
  }
  return APP_OK;
}

extern SNodeP pager_pin_io_n;
extern SNodeP pager_pin_ioa_n;
extern SNodeP pager_pin_on_level_n;
extern SNodeP pager_pin_value_in_n;
extern SNodeP pager_pin_value_out_n;
extern SNodeP pager_pin_reset_value_n;
extern SNodeP pager_pin_label_n;
extern SNodeP pager_pin_alarm_n;
extern SNodeP pager_pin_alarm_value_n;
extern SNodeP pager_pin_alarm_value_adc_n;
extern SNodeP pager_pin_alarm_level_n;

u8 pager_pin (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    SNode *n = ctx->n;
    u8 pin = rw (&n->p) - 'A';
    u8 input = rb (&pers_mem->pin[pin].dir);

    if (input == DEF_IN || input == DEF_ADC)
    {
      if (rb (&pers_mem->pin[pin].alarm))
      {
	if (input == DEF_ADC)
	{
	  spider_append_r (ctx, &pager_pin_alarm_level_n);
	  spider_append_r (ctx, &pager_pin_alarm_value_adc_n);
	}
	else
	  spider_append_r (ctx, &pager_pin_alarm_value_n);
      }

      spider_append_r (ctx, &pager_pin_alarm_n);
      spider_append_r (ctx, &pager_pin_value_in_n);
    }
    else if (input == DEF_OUT)
    {
      spider_append_r (ctx, &pager_pin_reset_value_n);
      spider_append_r (ctx, &pager_pin_value_out_n);
      spider_append_r (ctx, &pager_pin_on_level_n);
    }

    if (pin < 9)
      spider_append_r (ctx, &pager_pin_io_n);
    else
      spider_append_r (ctx, &pager_pin_ioa_n);

    spider_append_r (ctx, &pager_pin_label_n);
  }
  else if (action == APP_LEAVE)
  {
    spider_clear_r (ctx);
  }
  return APP_OK;
}

u8 pager_pin_io (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = ctx->parent->f;
    u8 *text = locale (rw (&n->text));
    u8 pin = rw (&np->p) - 'A';
    u8 val = rb (&pers_mem->pin[pin].dir);

    if (val == DEF_IN)
      val = 0;
    else
      val = 1;
    res =
      ABC_val (&ret, val, text, locale (lc_Input), locale (lc_Output), NULL);
    if (res != APP_OK)
      return res;
    if (ret != val)
    {
      wb (&pers_mem->pin[pin].on_level, 1);
      wb (&pers_mem->pin[pin].alarm, 0);
      wb (&pers_mem->pin[pin].alarm_val, 0);

      if (ret == 0)
      {
	ret = DEF_IN;
	set_dir (pin, DEF_IN);
      }
      else
      {
	ret = DEF_OUT;
	set_dir (pin, DEF_OUT);
	set_pin (pin, DEF_OFF);
      }

      wb (&pers_mem->pin[pin].dir, ret);
    }
    return APP_BACK;
  }
  return APP_OK;
}

u8 pager_pin_ioa (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = ctx->parent->f;
    u8 *text = locale (rw (&n->text));
    u8 pin = rw (&np->p) - 'A';
    u8 val = rb (&pers_mem->pin[pin].dir);

    if (val == DEF_IN)
      val = 0;
    else if (val == DEF_OUT)
      val = 1;
    else
      val = 2;

    res =
      ABC_val (&ret, val, text, locale (lc_Input), locale (lc_Output),
	       locale (lc_ADC));
    if (res != APP_OK)
      return res;
    if (ret != val)
    {
      wb (&pers_mem->pin[pin].alarm, 0);
      wb (&pers_mem->pin[pin].alarm_val, 0);
      wb (&pers_mem->pin[pin].on_level, 1);
      ww (&pers_mem->pin[pin].adc_threshold, 0);

      if (ret == 0)
      {
	ret = DEF_IN;
	set_dir (pin, DEF_IN);
      }
      else if (ret == 1)
      {
	ret = DEF_OUT;
	set_dir (pin, DEF_OUT);
	set_pin (pin, DEF_OFF);
      }
      else
      {
	ret = DEF_ADC;
	set_dir (pin, DEF_ADC);
      }

      wb (&pers_mem->pin[pin].dir, ret);
    }
    return APP_BACK;
  }
  return APP_OK;
}

u8 pager_pin_on_level (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = ctx->parent->f;
    u8 *text = locale (rw (&n->text));
    u8 pin = rw (&np->p) - 'A';
    u8 val = rb (&pers_mem->pin[pin].on_level);

    res = ABC_val (&ret, val, text, locale (lc_Low), locale (lc_Hi), NULL);
    if (res != APP_OK)
      return res;
    if (ret != val)
    {
      wb (&pers_mem->pin[pin].on_level, ret);
    }
    return APP_BACK;
  }
  return APP_OK;
}

u8 pager_pin_alarm (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = ctx->parent->f;
    u8 *text = locale (rw (&n->text));
    u8 pin = rw (&np->p) - 'A';
    u8 val = rb (&pers_mem->pin[pin].alarm);

    res = ABC_val (&ret, val, text, locale (lc_No), locale (lc_Yes), NULL);
    if (res != APP_OK)
      return res;
    if (ret != val)
      wb (&pers_mem->pin[pin].alarm, ret);
    return APP_BACK;
  }
  return APP_OK;
}

u8 pager_pin_alarm_value (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = ctx->parent->f;
    u8 *text = locale (rw (&n->text));
    u8 pin = rw (&np->p) - 'A';
    u8 val = rb (&pers_mem->pin[pin].alarm_val);

    res =
      ABC_val (&ret, val, text, locale (lc_Low), locale (lc_Hi),
	       locale (lc_FlipFlop));
    if (res != APP_OK)
      return res;
    if (ret != val)
    {
      wb (&pers_mem->pin[pin].alarm_val, ret);
      if (ret == 2)		// flip-flop
	alarm_flipflop[pin] = get_val_pin (pin);
    }
    return APP_BACK;
  }
  return APP_OK;
}

u8 pager_pin_alarm_value_adc (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    SNode *np = ctx->parent->f;
    u8 pin = rw (&np->p) - 'A';
    u16 adc_val = rw (&pers_mem->pin[pin].adc_threshold);
    u8 l;
    u8 label[10];
    u16 ret;

    res = label;
    res = sprinti (res, adc_val);
    res = sprintc (res, '\0');
    res =
      get_input (locale (lc_Alarm_Threshold), 0, 5, label,
		 Q_GET_INPUT_DIGITS);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;
    res[res[0] + 1] = '\0';
    ret = atoi (&res[2]);

    if (ret != adc_val)
      ww (&pers_mem->pin[pin].adc_threshold, ret);
    return APP_BACK;
  }
  return APP_OK;
}

u8 pager_pin_alarm_level (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = ctx->parent->f;
    u8 *text = locale (rw (&n->text));
    u8 pin = rw (&np->p) - 'A';
    u8 val = rb (&pers_mem->pin[pin].alarm_val);

    res = ABC_val (&ret, val, text, locale (lc_Less), locale (lc_More), NULL);
    if (res != APP_OK)
      return res;
    if (ret != val)
      wb (&pers_mem->pin[pin].alarm_val, ret);
    return APP_BACK;
  }
  return APP_OK;
}

u8 pager_pin_value_in (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *buf = buf_B ();
    u8 *r = buf;
    u8 i;
    SNode *np = ctx->parent->f;
    u8 pin = rw (&np->p) - 'A';
    u8 val = rb (&pers_mem->pin[pin].dir);

    r = sprints (r, locale (lc_Value));
    r = sprintc (r, ':');
    r = sprintc (r, ' ');
    if (rb (&pers_mem->pin[pin].dir) == DEF_IN)
      r = sprintc (r, '0' + get_val_pin (pin));
    else
      r = sprinti (r, get_pin_adc (pin));
    r = sprintc (r, '\n');
    r = sprintc (r, '\0');
    i = display_text (buf, NULL);
    if (i != APP_END)
      return APP_BACK;
    return i;
  }
  return APP_OK;
}

u8 pager_pin_value_out (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = ctx->parent->f;
    u8 *text = locale (rw (&n->text));
    u8 pin = rw (&np->p) - 'A';
    u8 val = out_pin_val (pin);

    if (val == DEF_ON)
      val = 0;
    else
      val = 1;

    res = ABC_val (&ret, val, text, locale (lc_On), locale (lc_Off), NULL);
    if (res != APP_OK)
      return res;
    if (ret != val)
    {
      if (ret == 0)
	val = DEF_ON;
      else
	val = DEF_OFF;
      set_pin (pin, val);
    }
    return APP_BACK;
  }
  return APP_OK;
}

u8 pager_pin_label (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    SNode *np = ctx->parent->f;
    u8 pin = rw (&np->p) - 'A';
    u8 *label = rw (&pers_mem->pin[pin].label);
    u8 l;

    res =
      get_input (locale (lc_Enter_Label), 0, 9, label, Q_GET_INPUT_ALPHABET);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;

    efree (label);

    l = res[0];

    if (l < 2)
    {
      label = NULL;
    }
    else
    {
      res[res[0] + 1] = '\0';
      label = emalloc (l);
      if (label == NULL)
      {
	ww (&pers_mem->pin[pin].label, NULL);
	return perror (ERR_NO_EEPROM);
      }

      memcpy (label, res + 2, l);
    }
    ww (&pers_mem->pin[pin].label, label);

    return APP_BACK;
  }
  return APP_OK;
}

u8 pager_pin_reset_value (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res, ret;
    SNode *n = ctx->n;
    SNode *np = ctx->parent->f;
    u8 *text = locale (rw (&n->text));
    u8 pin = rw (&np->p) - 'A';
    u8 val = rb (&pers_mem->pin[pin].init_val);

    if (val == DEF_ON)
      val = 0;
    else
      val = 1;

    res = ABC_val (&ret, val, text, locale (lc_On), locale (lc_Off), NULL);
    if (res != APP_OK)
      return res;
    if (ret != val)
      wb (&pers_mem->pin[pin].init_val, !rb (&pers_mem->pin[pin].init_val));
    return APP_BACK;
  }
  return APP_OK;
}

u8 PROGMEM t_bladox[] = "www.bladox.com";

u8 pager_version (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *buf = buf_B ();
    u8 *r = buf;
    u8 i;

    r = sprints (r, locale (lc_Pager));
    r = sprintc (r, '-');
    r = sprintc (r, VERSION_A + '0');
    r = sprintc (r, '.');
    r = sprintc (r, VERSION_B + '0');
    r = sprintc (r, '.');
    r = sprintc (r, VERSION_C + '0');
    r = sprintc (r, '\n');
    r = sprints (r, t_bladox);
    r = sprintc (r, '\0');

    i = display_text (buf, NULL);
    if (i != APP_END)
      return APP_BACK;
    return i;
  }
  return APP_OK;
}

b8 my_poll_interval (u8 d)
{
  u8 *res;
  u8 j;

  dbsp ("MY_POLL_INT\n");

  poll_int = 30;
  res = poll_interval (DURATION_SEC, d);
  j = get_tag (res, T_RESULT);
  if (j == 0)
    return -1;
  j++;				// tag
  j++;				// len
  if (res[j] != 0x00)
  {
    dbsp ("SET POLL INTERVAL ERROR\n");
    return -1;
  }

  j = get_tag (res, T_DURATION);
  if (j == 0)
    return -1;
  j++;				// tag
  j++;				// len
  dbsp ("POLL INT UNITS ");
  dbch (res[j]);
  dbc ('\n');
  j++;				// units
  dbsp ("POLL INT ");
  dbch (res[j]);
  dbc ('\n');
  poll_int = res[j];
  return res[j];
}

u8 pager_poll_interval_delay (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    u8 x;
    u8 *t = buf_B ();
    b8 d;

    d = my_poll_interval (rb (&pers_mem->poll_interval));
    if (d < 0)
      if (display_text (locale (lc_Poll_Interval_Error), NULL) == APP_END)
	return APP_END;

    res = t;
    res = sprinti (res, d);
    res = sprintc (res, '\0');

    res = get_input (locale (lc_Seconds), 1, 2, t, Q_GET_INPUT_DIGITS);
    if (res == ENULL)
      return APP_END;
    if (res == NULL)
      return APP_BACK;
    res[res[0] + 1] = '\0';
    x = atoi (&res[2]);
    if (x == 0)
      x = 1;
    d = my_poll_interval (x);
    res = t;
    res = sprints (res, locale (lc_Poll_Interval_Set));
    res = sprinti (res, d);
    res = sprints (res, locale (lc_Seconds_2));
    res = sprintc (res, '\0');
    if (display_text (t, NULL) == APP_END)
      return APP_END;
    if (d != rb (&pers_mem->poll_interval))
      wb (&pers_mem->poll_interval, d);
    return APP_BACK;
  }
  return APP_OK;
}

u8 pager_poll_interval_help (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    if (display_text (locale (lc_Help_Poll_Interval), NULL) == APP_END)
      return APP_END;
    return APP_BACK;
  }
  return APP_OK;
}

SNodeP pager_n = { lc_Pager, NULL };
SNodeP pager_n_config = { lc_Config, NULL };
SNodeP pager_version_n = { lc_Version, pager_version };
SNodeP pager_poll_interval_n = { lc_Poll_Interval, NULL };
SNodeP pager_poll_interval_delay_n =
  { lc_Poll_Interval, pager_poll_interval_delay };
SNodeP pager_poll_interval_help_n = { lc_Help, pager_poll_interval_help };

SNodeP pager_n_new_number = { lc_New_Number, pager_new_number };
SNodeP pager_n_numbers = { lc_Numbers, pager_numbers };
SNodeP pager_clear_sim_sms_n = { lc_Clear_SIM_SMS, pager_clear_sim_sms };

SNodeP pager_number_view_n = { LC_VIEW, pager_number_view };
SNodeP pager_number_delete_n = { LC_DELETE, pager_number_delete };

SNodeP pager_state_n = { lc_State, pager_state };
SNodeP pager_pin_a_n = { lc_PIN_A, pager_pin, 'A' };
SNodeP pager_pin_b_n = { lc_PIN_B, pager_pin, 'B' };
SNodeP pager_pin_c_n = { lc_PIN_C, pager_pin, 'C' };
SNodeP pager_pin_d_n = { lc_PIN_D, pager_pin, 'D' };
SNodeP pager_pin_e_n = { lc_PIN_E, pager_pin, 'E' };
SNodeP pager_pin_f_n = { lc_PIN_F, pager_pin, 'F' };
SNodeP pager_pin_g_n = { lc_PIN_G, pager_pin, 'G' };
SNodeP pager_pin_h_n = { lc_PIN_H, pager_pin, 'H' };
SNodeP pager_pin_i_n = { lc_PIN_I, pager_pin, 'I' };

#ifdef CONFIG_TURBO_LITE
SNodeP pager_pin_j_n = { lc_PIN_J, pager_pin, 'J' };
SNodeP pager_pin_k_n = { lc_PIN_K, pager_pin, 'K' };
SNodeP pager_pin_l_n = { lc_PIN_L, pager_pin, 'L' };
SNodeP pager_pin_m_n = { lc_PIN_M, pager_pin, 'M' };
#endif

SNodeP pager_pin_io_n = { lc_IO, pager_pin_io };
SNodeP pager_pin_ioa_n = { lc_IOA, pager_pin_ioa };
SNodeP pager_pin_on_level_n = { lc_On_Level, pager_pin_on_level };
SNodeP pager_pin_value_in_n = { lc_Value, pager_pin_value_in };
SNodeP pager_pin_value_out_n = { lc_Value, pager_pin_value_out };
SNodeP pager_pin_reset_value_n = { lc_RESET_Value, pager_pin_reset_value };
SNodeP pager_pin_label_n = { lc_Label, pager_pin_label };
SNodeP pager_pin_alarm_n = { lc_Alarm, pager_pin_alarm };
SNodeP pager_pin_alarm_value_n = { lc_Alarm_Level, pager_pin_alarm_value };
SNodeP pager_pin_alarm_value_adc_n =
  { lc_Alarm_Threshold, pager_pin_alarm_value_adc };
SNodeP pager_pin_alarm_level_n = { lc_Alarm_Level, pager_pin_alarm_level };

/* *INDENT-OFF* */

SEdgeP pager_edges_p[] = {
  {&pager_n, &pager_n_numbers},
  {&pager_n, &pager_n_config},
  {&pager_n, &pager_version_n},
  {&pager_n_numbers, &pager_n_new_number},
  {&pager_n_config, &pager_state_n},
  {&pager_n_config, &pager_poll_interval_n},
#ifdef CONFIG_TURBO_LITE
  {&pager_n_config, &pager_pin_j_n},
  {&pager_n_config, &pager_pin_k_n},
  {&pager_n_config, &pager_pin_l_n},
  {&pager_n_config, &pager_pin_m_n},
#endif
  {&pager_n_config, &pager_pin_a_n},
  {&pager_n_config, &pager_pin_b_n},
  {&pager_n_config, &pager_pin_c_n},
  {&pager_n_config, &pager_pin_d_n},
  {&pager_n_config, &pager_pin_e_n},
  {&pager_n_config, &pager_pin_f_n},
  {&pager_n_config, &pager_pin_g_n},
  {&pager_n_config, &pager_pin_h_n},
  {&pager_n_config, &pager_pin_i_n},
  {&pager_n_config, &pager_clear_sim_sms_n},
  {&pager_poll_interval_n, &pager_poll_interval_delay_n},
  {&pager_poll_interval_n, &pager_poll_interval_help_n},
  NULL
};

/* *INDENT-ON* */

u8 send_status (u8 * ms, u8 type)	// 0 - failed, 1 - sent ok
{
  u8 *tmp = malloc (140);
  u8 *r = tmp;
  u8 *s;
  u8 i, j;
  u16 val;

  dbsp (">send_status\n");

  i = print_state (tmp, 140) - 1;	// minus '\0'
  i = dcs_78 (tmp, i, DCS_8_TO_7);
  r = send_sms (tmp, i, ms, type, 0, 0, NULL, NULL);
  free (tmp);

  i = get_tag (r, T_RESULT);
  if (i != 0)
  {
    i += 2;
    if (r[i] == 0x00)
    {
      dbsp ("SEND_SMS OK\n");
      return 1;
    }
  }
  dbsp ("SEND_SMS NOT_OK\n");
  return 0;
}

static u8 PROGMEM t_keyword_on[] = "ON ";
static u8 PROGMEM t_keyword_off[] = "OFF ";
static u8 PROGMEM t_keyword_btn[] = "BTN ";

void rec_sms (File_apdu_data * fd)
{
  u8 *t;
  u8 *data = fd->data;
  u8 i, j;
  u16 msecs;
  u8 *s;
  u8 l;
  u8 cmd = 0;
  u8 pin;
  SEdge *nrs = rw (&pers_mem->numbers);
  SNode *n;
  u8 *ms;

#define CMD_NO		0
#define CMD_ON		1
#define CMD_OFF		2
#define CMD_BTN		3

  cmd = CMD_NO;

#ifdef DEBUG
  dbsp ("REC_SMS\n");
  for (i = 0; i < fd->p3; i++)
  {
    dbch (data[i]);
    dbc (' ');
  }
  dbc ('\n');
#endif

  if ((data[0] & 0x07) == 3)	//received, to be read
  {
    s = data;
    s++;			// status
    i = *s;
    s += i + 1;			// TS-Service-Centre-Address

    i = *s;
    if ((i & 0x03) == 0x00)	//deliver
    {
      t = tpdu_seek (s, T_SMS_DCS);
      if (dcs_is_7b (*t))
      {
	t = tpdu_seek (s, T_SMS_UDL);
	i = *t;
	dcs_78 (t + 1, i, DCS_7_TO_8);
      }

// check nr
      t = tpdu_seek (s, T_SMS_AA);
      ms = msisdncpy (t, MSISDN_SMS, MEM_R);

      if (nrs != NULL)
      {
	while (nrs != NULL)
	{
	  n = rw (&nrs->t);

	  if (msisdncmp (rw (&n->p), MSISDN_ADN, ms, MSISDN_SMS))
	    goto X_NR_OK;
	  nrs = rw (&nrs->next);
	}

// number not allowed, delete message and return
	refsms_d (fd);
	free (ms);
	return;
      }

    X_NR_OK:
      t = tpdu_seek (s, T_SMS_UDL);
      l = *t;
      t++;

      if (l > sizeof (t_keyword_on) - 1 && cmd == CMD_NO)
      {
	for (i = 0; i < sizeof (t_keyword_on) - 1; i++)
	  if (toupper (t[i]) != rb (t_keyword_on + i))
	    goto X_OFF;
	cmd = CMD_ON;
      }

    X_OFF:
      if (l > sizeof (t_keyword_off) - 1 && cmd == CMD_NO)
      {

	for (i = 0; i < sizeof (t_keyword_off) - 1; i++)
	  if (toupper (t[i]) != rb (t_keyword_off + i))
	    goto X_BTN;
	cmd = CMD_OFF;
      }

    X_BTN:
      if (l > sizeof (t_keyword_btn) - 1 && cmd == CMD_NO)
      {
	for (i = 0; i < sizeof (t_keyword_btn) - 1; i++)
	  if (toupper (t[i]) != rb (t_keyword_btn + i))
	    goto X_NO_CMD;
	cmd = CMD_BTN;
      }

      dbsp ("CMD: ");
      dbch (cmd);
      dbc ('\n');

      if (cmd != CMD_NO)
      {
// check label
	t = t + i;
	l = l - i;

	dbsp ("LABELS ");
	dbch (l);
	dbc ('\n');
	for (i = 0; i < MAX_PIN; i++)
	{
	  if (rw (&pers_mem->pin[i].label) != NULL)
	  {
	    u8 *label = rw (&pers_mem->pin[i].label);

	    dbch (i);
	    dbc (' ');
	    dbch (strlen (label));
	    dbc ('\n');

	    if (l == strlen (label))
	    {
	      for (j = 0; j < l; j++)
	      {
		dbc (t[j]);
		dbc (' ');
		dbc (rb (label + j));
		if (toupper (t[j]) != toupper (rb (label + j)))
		{
		  dbc ('\n');
		  goto X_NEXT_LABEL;
		}
	      }
	      dbc ('\n');
	      pin = i;
	      goto X_LABEL_FOUND;
	    }
	  }
	X_NEXT_LABEL:
	}
	goto X_NO_CMD;		// no label found, syntax error

      X_LABEL_FOUND:
	if (rb (&pers_mem->pin[pin].dir) == DEF_OUT)
	  switch (cmd)
	  {
	    case CMD_ON:
	      set_pin (pin, DEF_ON);
	      break;
	    case CMD_OFF:
	      set_pin (pin, DEF_OFF);
	      break;
	    case CMD_BTN:
	      set_pin (pin, !out_pin_val (pin));
	      for (msecs = 0; msecs < CONFIG_BTN_DELAY_MILISEC; msecs++)
		delay_1ms ();
	      set_pin (pin, !out_pin_val (pin));
	      break;
	  }
      }

    X_NO_CMD:
      dbsp ("CMD_1: ");
      dbch (cmd);
      dbc ('\n');
      refsms_d (fd);
      dbsp ("send_sms\n");
      send_status (ms, MSISDN_SMS);
      dbsp ("send_sms_1\n");
      free (ms);
      return;
    }

    refsms_d (fd);
    return;
  }

  store_sms_2_sim ();		// not incoming message, something user
}

void send_alarm (Menu_selection_data * x)
{
  SEdge *nrs = rw (&pers_mem->numbers);
  SNode *n;
  u8 *ms;
  u8 i;

  while (nrs)
  {
    n = rw (&nrs->t);
    ms = msisdncpy (rw (&n->p), MSISDN_ADN, MEM_R);
    send_status (ms, MSISDN_ADN);
    free (ms);
    nrs = rw (&nrs->next);
  }
  for (i = 0; i < MAX_PIN; i++)
    if (alarm_reported[i] == 1)
      alarm_reported[i] = 2;
}

void set_poll_int (void *x)
{
  my_poll_interval (rb (&pers_mem->poll_interval));
}

void action_menu (Menu_selection_data * x)
{
  SCtx *c;

  c = spider_init ();
  spider_set_order (c, ORDER_R, ORDER_P, ORDER_E, ORDER_D);
  c->eP = &pager_edges_p;
  c->n = &pager_n;
  spider (c);
}

void turbo_handler (u8 action, void *data)
{
  switch (action)
  {
    case ACTION_APP_REGISTER:
      {
	Pers_mem *p = emalloc (sizeof (Pers_mem));

	if (p)
	{
	  u8 i;

	  for (i = 0; i < MAX_PIN; i++)
	  {
	    wb (&p->pin[i].dir, DEF_IN);	//input
	    wb (&p->pin[i].init_val, DEF_OFF);
	    wb (&p->pin[i].on_level, 1);
	    wb (&p->pin[i].alarm, 0);
	    wb (&p->pin[i].alarm_val, 0);
	    ww (&p->pin[i].adc_threshold, 0);
	    ww (&p->pin[i].label, NULL);
	  }
	  ww (&p->numbers, NULL);
	  wb (&p->poll_interval, DEF_POLL_INTERVAL);
	  reg_app_data (p);
	}
      }
      break;

    case ACTION_APP_UNREGISTER:
      {
	Pers_mem *p = app_data ();
	SEdge *e, *f;
	SNode *n;
	u8 *t;
	u8 i;

	for (i = 0; i < MAX_PIN; i++)
	  efree (rw (&p->pin[i].label));

	e = rw (&p->numbers);
	while (e)
	{
	  n = rw (&e->t);
	  t = rw (&n->text);
	  efree (t);
	  t = rw (&n->p);
	  efree (t);
	  efree (n);
	  f = rw (&e->next);
	  efree (e);
	  e = f;
	}

	efree (p);
      }
      break;

    case ACTION_SMS:
      stk_thread (rec_sms, data);
      break;

    case ACTION_APP_INIT:
      {
	u8 i;

	pers_mem = app_data ();
	for (i = 0; i < MAX_PIN; i++)
	{
	  alarm_reported[i] = 0;
	  set_dir (i, rb (&pers_mem->pin[i].dir));
	  if (rb (&pers_mem->pin[i].dir) == DEF_OUT)
	    set_pin (i, rb (&pers_mem->pin[i].init_val));
	  if (rb (&pers_mem->pin[i].dir) == DEF_IN)
	    alarm_flipflop[i] = get_val_pin (i);
	}
      }
      poll_int = 0xff;
      reg_action (ACTION_SMS);
      reg_action (ACTION_STATUS);
      break;

    case ACTION_INSERT_MENU:
      insert_menu (locale (lc_Pager));
      break;

    case ACTION_MENU_SELECTION:
      stk_thread (action_menu, data);
      break;

    case ACTION_STATUS:
      {
	u8 report_alarm = 0;
	u8 i;
	u16 adc_val;
	u8 val;

	if (poll_int == 0xff)
	  stk_thread (set_poll_int, NULL);

	for (i = 0; i < MAX_PIN; i++)
	{
	  if (rb (&pers_mem->pin[i].dir) == DEF_IN
	      && rb (&pers_mem->pin[i].alarm))
	  {
	    val = get_val_pin (i);

	    if (rb (&pers_mem->pin[i].alarm_val) == 2)	// flip-flop
	    {
	      if (val != alarm_flipflop[i])
	      {
		alarm_flipflop[i] = val;
		val = 1;
	      }
	      else
		val = 0;
	    }
	    else
	    {
	      if (val == rb (&pers_mem->pin[i].alarm_val))
		val = 1;
	      else
		val = 0;
	    }

	    if (val)
	    {
	      if (alarm_reported[i] == 0)
	      {
		report_alarm = 1;
		alarm_reported[i] = 1;
	      }
	    }
	    else if (alarm_reported[i] == 2)
	      alarm_reported[i] = 0;
	  }
	  else
	    if (rb (&pers_mem->pin[i].dir) == DEF_ADC
		&& rb (&pers_mem->pin[i].alarm))
	  {
	    val = 0;
	    adc_val = get_pin_adc (i);
	    if ((rb (&pers_mem->pin[i].alarm_val) == 0)
		&& (adc_val <= rw (&pers_mem->pin[i].adc_threshold)))
	      val = 1;
	    else
	      if (rb (&pers_mem->pin[i].alarm_val)
		  && (adc_val > rw (&pers_mem->pin[i].adc_threshold)))
	      val = 1;

	    if (val)
	    {
	      if (alarm_reported[i] == 0)
	      {
		report_alarm = 1;
		alarm_reported[i] = 1;
	      }
	    }
	    else if (alarm_reported[i] == 2)
	      alarm_reported[i] = 0;
	  }
	}

	if (report_alarm)
	  stk_thread (send_alarm, NULL);
      }
      break;

    default:
      break;
  }
}

